commit 9456601d039ca52f38db33e2606d22efbb873fef
Author: Petr Urban <urbanp@gapps.zcu.cz>
Date:   Wed Jul 13 19:51:00 2022 +0200

    merge

diff --git a/src/main/webapp/WEB-INF/templates/fragments/navbar.html b/src/main/webapp/WEB-INF/templates/fragments/navbar.html
index 43d981f..908d1a9 100644
--- a/src/main/webapp/WEB-INF/templates/fragments/navbar.html
+++ b/src/main/webapp/WEB-INF/templates/fragments/navbar.html
@@ -1,43 +1,48 @@
 <div th:fragment="navBar" xmlns:th="http://www.w3.org/1999/xhtml">
-    <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light" id="main-navbar">
-        <a th:href="@{/}" class="navbar-brand"><b>SPAWn</b> – SPADe Web Interface</a>
-        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
-            <span class="navbar-toggler-icon"></span>
-        </button>
-        <div class="collapse navbar-collapse" id="navbarSupportedContent">
-            <ul class="navbar-nav mr-auto">
-                <li class="nav-item active">
-                    <a class="nav-link" th:href="@{/detect}">Detect</a>
-                </li>
-                <li th:switch="${query} == null OR ${#lists.isEmpty(query.antiPatterns)}" class="nav-item active">
-                    <a th:case="false" class="nav-link" th:href="@{/configuration}">Configuration</a>
-                    <a th:case="true" class="nav-link" href="#" style="color: red">Configuration</a>
-                </li>
-                <li class="nav-item active">
-                    <a class="nav-link" th:href="@{/about}">About</a>
-                </li>
-            </ul>
-            <ul class="nav navbar-nav navbar-right">
-                <li class="nav-item active">
-                    <span class="nav-link" id="current-configuration-label">Configuration:</span>
-                </li>
-                <li class="nav-item active" id="current-configuration-box">
-                    <form id="configuration-form" th:action="@{/setSelectedConfiguration}" method="post">
-                        <select class="form-control" id="current-configuration-select" name="current-configuration-select" onchange="this.form.submit()">
-                            <option th:each="configuration : ${configurationList}" th:value = ${configuration} th:text = ${configuration} th:selected="${#strings.equals(configuration, selectedConfiguration)}"></option>
-                        </select>
-                    </form>
-                </li>
-                <li class="nav-item active">
-                    <span class="nav-link" id="user-name-container" hidden></span>
-                </li>
-                <li class="nav-item active">
-                    <a class="btn btn-primary" th:href="@{/login}" id="login-button" hidden>Log In</a>
-                </li>
-                <li class="nav-item active">
-                    <a class="btn btn-outline-primary" th:href="@{/logout}" id="logout-button" hidden>Log Out</a>
-                </li>
-            </ul>
+    <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
+        <div class="container-fluid">
+            <a class="navbar-brand"><b>SPAWn</b> – SPADe Web Interface</a>
+            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
+                    aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
+                <span class="navbar-toggler-icon"></span>
+            </button>
+            <div class="collapse navbar-collapse" id="navbarSupportedContent">
+                <ul class="navbar-nav mr-auto">
+                    <li class="nav-item active">
+                        <a class="nav-link" th:href="@{/detect}">Detect</a>
+                    </li>
+                    <li th:if="${not #lists.isEmpty(query.antiPatterns)}" class="nav-item active">
+                        <a class="nav-link" th:href="@{/configuration}">Configuration</a>
+                    </li>
+                    <li class="nav-item active">
+                        <a class="nav-link" th:href="@{/about}">About</a>
+                    </li>
+                </ul>
+                <ul class="nav navbar-nav ms-auto">
+                    <li class="nav-item active">
+                        <span class="nav-link" id="current-configuration-label">Configuration:</span>
+                    </li>
+                    <li class="nav-item active" id="current-configuration-box">
+                        <form id="configuration-form" th:action="@{/setSelectedConfiguration}" method="post">
+                            <select class="form-control" id="current-configuration-select"
+                                    name="current-configuration-select" onchange="this.form.submit()">
+                                <option th:each="configuration : ${configurationList}" th:value=${configuration}
+                                        th:text=${configuration}
+                                        th:selected="${#strings.equals(configuration, selectedConfiguration)}"></option>
+                            </select>
+                        </form>
+                    </li>
+                    <li class="nav-item active">
+                        <span class="nav-link" id="user-name-container" hidden></span>
+                    </li>
+                    <li class="nav-item active">
+                        <a class="btn btn-primary" th:href="@{/login}" id="login-button" hidden>Log In</a>
+                    </li>
+                    <li class="nav-item active">
+                        <a class="btn btn-outline-primary" th:href="@{/logout}" id="logout-button" hidden>Log Out</a>
+                    </li>
+                </ul>
+            </div>
         </div>
     </nav>
 </div>