commit a26d9f940fb7db6113d372bae130504f5b654bca
Author: stepanekp <1stepanekpetr@gmail.com>
Date:   Sat May 14 21:25:07 2022 +0200

    #22 Terminology fixed

diff --git a/src/main/webapp/WEB-INF/templates/anti-pattern.html b/src/main/webapp/WEB-INF/templates/anti-pattern.html
index ccf623f..410b993 100644
--- a/src/main/webapp/WEB-INF/templates/anti-pattern.html
+++ b/src/main/webapp/WEB-INF/templates/anti-pattern.html
@@ -67,7 +67,7 @@
 
         <!-- Anti pattern description -->
         <div class="form-group">
-            <h5 for="antiPatternDescription">Anti Pattern Description</h5>
+            <h5 for="antiPatternDescription">Anti-pattern Description</h5>
             <textarea disabled class="form-control" id="antiPatternDescription" rows="5"
                       th:text="${description}"></textarea>
         </div>
@@ -77,7 +77,7 @@
 
         <!-- Anti pattern operationalization -->
         <div class="operationalization-detail">
-            <h5 style="display: inline-block">Anti Pattern Operationalization Detail</h5>
+            <h5 style="display: inline-block">Anti-pattern Operationalization Detail</h5>
             <button type="button" class="btn edit-button" id="operationalizationEditButton" onclick="enableEdit()">
                 <i class="fa fa-pen-to-square fa-lg"></i>
             </button>
@@ -143,7 +143,7 @@
         <hr>
 
         <!-- Anti pattern configuration form -->
-        <h5>Anti Pattern Configurations</h5>
+        <h5>Anti-pattern Configurations</h5>
 
         <!-- Form for configuration values -->
         <form action="#" th:action="@{/anti-patterns/} + ${antiPattern.id}" th:object="${antiPattern}" method="post">
diff --git a/src/main/webapp/WEB-INF/templates/fragments/navbar.html b/src/main/webapp/WEB-INF/templates/fragments/navbar.html
index f593080..fd8d039 100644
--- a/src/main/webapp/WEB-INF/templates/fragments/navbar.html
+++ b/src/main/webapp/WEB-INF/templates/fragments/navbar.html
@@ -1,13 +1,13 @@
 <div th:fragment="navBar" xmlns:th="http://www.w3.org/1999/xhtml">
     <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light" id="main-navbar">
-        <a class="navbar-brand"><b>SPAWn</b> - SPADe Web Interface</a>
+        <a class="navbar-brand"><b>SPAWn</b> – SPADe Web Interface</a>
         <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
             <span class="navbar-toggler-icon"></span>
         </button>
         <div class="collapse navbar-collapse" id="navbarSupportedContent">
             <ul class="navbar-nav mr-auto">
                 <li class="nav-item active">
-                    <a class="nav-link" th:href="@{/}">Analyze</a>
+                    <a class="nav-link" th:href="@{/}">Detect</a>
                 </li>
                 <li class="nav-item active">
                     <a class="nav-link" th:href="@{/configuration}">Configuration</a>
diff --git a/src/main/webapp/WEB-INF/templates/index.html b/src/main/webapp/WEB-INF/templates/index.html
index 0015b4e..a44ae12 100644
--- a/src/main/webapp/WEB-INF/templates/index.html
+++ b/src/main/webapp/WEB-INF/templates/index.html
@@ -24,7 +24,7 @@
                 <h1>Projects</h1>
             </div>
             <div class="col">
-                <h1>Anti Patterns</h1><br>
+                <h1>Anti-patterns</h1><br>
             </div>
         </div>
 
@@ -37,7 +37,7 @@
                         <th scope="col">#</th>
                         <th scope="col">Project Name</th>
                         <th scope="col">Detail</th>
-                        <th scope="col">Analyze?</th>
+                        <th scope="col">Detect?</th>
                     </tr>
                     </thead>
                     <tbody>
@@ -70,9 +70,9 @@
                     <thead>
                     <tr>
                         <th scope="col">#</th>
-                        <th scope="col">Anti Pattern</th>
+                        <th scope="col">Anti-pattern</th>
                         <th scope="col">Detail</th>
-                        <th scope="col">Analyze?</th>
+                        <th scope="col">Detect?</th>
                     </tr>
                     </thead>
                     <tbody>
@@ -120,7 +120,7 @@
 
     <!-- Container for analyze button -->
     <div class="analyze-button-container">
-        <button id="analyzeButton" type="submit" class="btn btn-primary btn-lg btn-block" onclick="showProgressBar()">Analyze</button>
+        <button id="analyzeButton" type="submit" class="btn btn-primary btn-lg btn-block" onclick="showProgressBar()">Detect</button>
     </div>
     <!-- ./Container for analyze button -->
 